<template>
  <PageCard>
    <PageCard
      class="pageCard-padding"
      :title="$t('authorization.step2.part1.title')"
      dark
      :bordering="false"
      pointColor="#36d253">
      <ul
        class="signIn_inner-description ul">
        <li
          v-for="(item, key) in $t('authorization.step2.part1.description')"
          :key="key">{{item}}
        </li>
      </ul>
    </PageCard>
    <PageCard
      class="pageCard-padding"
      :title="$t('common.keys')"
      :pointed="false"
      :bordering="false">
      <div>
        <div class="text-uppercase text-bold text-medium color-accent-light mt-10 mb-10">Owner</div>
        <BInput
          v-model="privateKeyOwner"
          color="#00bac3"></BInput>
      </div>
      <div>
        <div class="text-uppercase text-bold text-medium color-accent-light mt-10 mb-10">Active</div>
        <BInput
          v-model="privateKeyActive"
          color="#00bac3"></BInput>
      </div>
    </PageCard>
    <PageCard :bordering="false">
      <div class="signIn_inner-body mb-20 flex flex-center">
        <StepLabel :active="active.copy">1</StepLabel>
        <BtnDark
          color="#8591a9"
          :backgroundColor="copied ? '#36d253' : '#192233'"
          borderColor="#36d253"
          @click="copy">{{$t('authorization.step2.part1.copy')}}
          <template slot="img">
            <IconCopy
              class="mt-3p ml-10"
              fill="#8591a9"></IconCopy>
          </template>
        </BtnDark>
      </div>
    </PageCard>
    <PageCard
      class="pageCard-padding"
      dark
      :bordering="false">
      <StepLabel
        :active="active.checkboxes">2
      </StepLabel>
      <div class="signIn_inner-checkboxWrapper">
        <Checkbox
          :disabled="!copied"
          v-model="checked_1"
          @change="change($event, 'checked_1')">{{$t('authorization.step2.part1.check1')}}
        </Checkbox>
        <Checkbox
          :disabled="!copied"
          v-model="checked_2"
          @change="change($event, 'checked_2')">{{$t('authorization.step2.part1.check2')}} <a href="" class="color-accent-light" @click.prevent="showComponent('Terms')">{{$t('authorization.step2.part1.check2_terms')}}</a>
        </Checkbox>
      </div>
    </PageCard>
    <PageCard :bordering="false">
      <StepLabel
        :active="active.btn">3
      </StepLabel>
      <div class="signIn_inner-body flex flex-center">
        <div class="signIn_inner-padding">
          <Btn
            transparent
            style="margin-bottom:0px; width: 250px;"
            @click="nextStep"
            :disabled="!checked_1 || !checked_2">{{$t('authorization.step2.part1.continue')}}
          </Btn>
        </div>
      </div>
    </PageCard>
  </PageCard>
</template>

<script>
  import Checkbox from '~/components/UI/Checkbox';
  import Btn from '~/components/UI/BtnSign_plain';
  import BInput from '~/components/UI/Input';
  import BtnDark from '~/components/UI/BtnSign_dark';
  import IconCopy from '~/components/UI/icons/icon-copy';
  import PageCard from '~/components/UI/PageCard';
  import StepLabel from '~/components/UI/StepLabel'
  import {Wallet} from '~/services/wallet/';
  import copyClipboard from '~/components/utils/copy';


  export default {
    name: "Step2_ThePart1",
    data() {
      return {
        checked_1: false,
        checked_2: false,
        privateKeyOwner: '',
        privateKeyActive: '',
        copied: false,
        active: {
          copy: true,
          checkboxes: false,
          btn: false
        }
      }
    },
    components: {
      BtnDark,
      Checkbox,
      Btn,
      BInput,
      IconCopy,
      PageCard,
      StepLabel
    },
    computed: {
      mnemonic() {
        return this.$store.state.signIn.mnemonic;
      }
    },
    methods: {
      change(val, field) {
        this[field] = val;
        this.$emit('allChecked', this.checked_1 && this.checked_2);
        if (this.checked_1 && this.checked_2) {
          this.active.btn = true;
        } else {
          this.active.btn = false;
        }
      },
      nextStep() {
        this.$emit('nextStep');
      },
      copy() {
        const text = `${Wallet.activePrivateKey} - Active private key\n${Wallet.ownerPrivateKey} - Owner private key`;
        const additionalText = `\n——————\n\nDISCLAMER: Only you own these keys and are fully responsible for them, so KEEP YOUR PRIVATE KEYS SAFE! The 16bit.game team has never known them and will not be able to help you recover them in case of loss!\n\nSecurity precautions in cryptocurrency world are a must! Without them you will quickly lose your funds. Here are some tips:\nI. DO NOT SHARE YOUR PRIVATE KEYS WITH ANYONE, NEVER\nII. Use the active key for everyday use, and the owner key for security operations only (such as active key rotation, etc.).\n\nIf your Active key was exposed or changed without your consent you can reset your Active key using your Owner key. This means that your Owner key is the single most sensitive thing you have and should be kept safe. If you are ever required to use your Owner key then it should be immediately reset. Consider it a one-time-use key.`;

        this.copied = true;
        this.active.checkboxes = true;
        copyClipboard(text + '\n' + additionalText, this.$t('common.copy'));
      },
      showComponent(component) {
        if(!this.checked_2) return;
        this.$store.commit('common/SET_SHOWING_MODAL', component);
      }
    },
    watch: {
      'mnemonic': {
        handler: function () {
          const length = 16;
          const activeKey = Wallet.activePrivateKey;
          const ownerKey = Wallet.ownerPrivateKey;
          this.privateKeyActive = activeKey.substring(0, length) + ' ... ' + activeKey.substring(activeKey.length - length, activeKey.length);
          this.privateKeyOwner = ownerKey.substring(0, length) + ' ... ' + ownerKey.substring(ownerKey.length - length, ownerKey.length);
        },
        immediate: true
      }
    }
  }
</script>
